// timer.cpp

#include	"timer.h"

bool	about=FALSE;

main()
{
	timer*	app;
	app=new timer();	app->Run();		delete app;
	return true;
}
//------------------------------------------------
timer::timer():BApplication("application/Beer/timer")
{
	timerwindow* window=new timerwindow(BRect(50,50,550,550));
}

void timer::AboutRequested()
{
	if(!about){
		about=TRUE;
		aboutwindow* window=new aboutwindow(BRect(350,50,550,200));
	}
}
//------------------------------------------------
timerwindow::timerwindow(BRect frame):BWindow(frame,"timer ver.0.00",B_TITLED_WINDOW,0)
{
	BRect	tframe;
	tframe.Set(0,0,500,500);			tframe.OffsetTo(0,0);
	tview=new timerview(tframe);		AddChild(tview);
	Show();
	SetPulseRate(200000);
}

bool timerwindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}
//------------------------------------------------
timerview::timerview(BRect frame):BView(frame,"timerview",B_NOT_RESIZABLE,B_WILL_DRAW|B_PULSE_NEEDED)
{
	min=0;	sec=0;	msec=0;
	drag=0;
	alm=0;
}

void timerview::AttachedToWindow()
{
	rgb_color	color={255,255,255};
	rgb_color	viewcolor={50,50,50};
	rgb_color	lowcolor={50,50,50};
	SetHighColor(color);
	SetViewColor(viewcolor);
	SetLowColor(lowcolor);
	SetFont(be_bold_font);
	SetFontSize(36);
}

void timerview::Draw(BRect rect)
{
	char	s[10];
	rgb_color	bdcolor={255,255,0};
	rgb_color	backcolor={20,50,210};
	rgb_color	numcolor={0,0,0};
	SetHighColor(bdcolor);
	FillEllipse(BPoint(250,250),235,235);
	SetHighColor(backcolor);
	FillEllipse(BPoint(250,250),230,230);
	SetHighColor(numcolor);
	for(int i=0;i<12;i++){
		sprintf(s,"%d",i);
		MovePenTo(cos(M_PI/6*(i-3))*200-StringWidth(s)/2+250,sin(M_PI/6*(i-3))*200+265);
		DrawString(s);
	}
	SetHighColor(numcolor);
	FillEllipse(BPoint(250,250),5,5);
	drawneedle(B_OP_ADD);
}

void timerview::drawneedle(int op)
{
	rgb_color	mincolor={50,180,20};
	rgb_color	seccolor={180,20,20};
	float srad=(sec*6+msec*0.006)*M_PI/180;
	float mrad=(min*30+sec*0.5+msec*0.0005)*M_PI/180;
	if(op==B_OP_ADD)SetDrawingMode(B_OP_ADD);
	if(op==B_OP_SUBTRACT)SetDrawingMode(B_OP_SUBTRACT);
	SetHighColor(seccolor);
	FillTriangle(BPoint(cos(srad-1.57)*220+250,sin(srad-1.57)*220+250),
	             BPoint(cos(srad+0.52)*10+250,sin(srad+0.52)*10+250),
	             BPoint(cos(srad+2.61)*10+250,sin(srad+2.61)*10+250));
	SetHighColor(mincolor);
	FillTriangle(BPoint(cos(mrad-1.57)*150+250,sin(mrad-1.57)*150+250),
	             BPoint(cos(mrad+0.52)*20+250,sin(mrad+0.52)*20+250),
	             BPoint(cos(mrad+2.61)*20+250,sin(mrad+2.61)*20+250));
	SetDrawingMode(B_OP_OVER);
}

void timerview::Pulse()
{
	if(drag>0){
		BPoint	pt;
		uint32	buttons;
		GetMouse(&pt,&buttons);
		if(!buttons&B_PRIMARY_MOUSE_BUTTON)MouseUp(pt);
	}else{
		if((min>0)||(sec>0)||(msec>0)){
			drawneedle(B_OP_SUBTRACT);
			if((msec-=200)<0){msec=800;if(--sec<0){sec=59;min--;}}
			drawneedle(B_OP_ADD);
		}
		if((min==0)&&(sec==0)&&(msec==0)&&(alm>0)){
			alm--;
			beep();beep();beep();
			return;
		}
	}
}

void timerview::MouseDown(BPoint pt)
{
	if((min==0)&&(sec==0)&&(msec==0))alm=0;
	if((pt.x>=450)&&(pt.y<=50))be_app->PostMessage(B_ABOUT_REQUESTED);
	float x=pt.x-250;
	float y=pt.y-250;
	int deg=atan(y/x)*180/M_PI;
	deg=(x>=0)?deg+90:deg+270;
	drag=0;
	if((deg-10<=sec*6)&&(sec*6<=deg+10))drag|=1;
	if((deg-10<=min*30+sec*0.5)&&(min*30+sec*0.5<=deg+10))drag|=2;
	if(drag==3)drag=((x*x+y*y)>150*150)?1:2;
}

void timerview::MouseUp(BPoint pt)
{
	drag=0;
}

void timerview::MouseMoved(BPoint pt,uint32 code,const BMessage *msg)
{
	if(drag>0){
		int old=sec;
		alm=100;
		float x=pt.x-250;
		float y=pt.y-250;
		int deg=atan(y/x)*180/M_PI;
		deg=(x>=0)?deg+90:deg+270;
		drawneedle(B_OP_SUBTRACT);
		if(drag==1){
			sec=deg/6;
			if(sec-old>30)min=(min>0)?min-1:11;
			if(old-sec>30)min=(min<11)?min+1:0;
		}
		if(drag==2)min=deg/30;
		drawneedle(B_OP_ADD);
	}
}
//------------------------------------------------
aboutwindow::aboutwindow(BRect frame):BWindow(frame,"about (timer)",B_TITLED_WINDOW,B_NOT_RESIZABLE)
{
	BRect	aframe;
	aframe.Set(0,0,200,150);		aframe.OffsetTo(0,0);
	aview=new aboutview(aframe);	AddChild(aview);
	Show();
}

bool aboutwindow::QuitRequested()
{
	about=FALSE;
	return true;
}
//------------------------------------------------
aboutview::aboutview(BRect frame):BView(frame,"aboutview",B_NOT_RESIZABLE,B_WILL_DRAW)
{
}

void aboutview::AttachedToWindow()
{
	rgb_color	color={0,0,0};
	rgb_color	viewcolor={222,255,222};
	rgb_color	lowcolor={222,255,222};
	SetHighColor(color);
	SetViewColor(viewcolor);
	SetLowColor(lowcolor);
	SetFont(be_plain_font);
}

void aboutview::Draw(BRect rect)
{
	SetFontSize(18);
	MovePenTo(30,30);		DrawString("TIMER  ver.0.00");
	SetFontSize(12);
	MovePenTo(100,60);		DrawString("1997.12.26");
	MovePenTo(50,100);		DrawString("by Hiroyuki Tsutsumi");
	MovePenTo(15,120);		DrawString("hirotsu@blue.plala.or.jp");
	MovePenTo(15,140);		DrawString("http://www1.plala.or.jp/hirotsu/");
}
